// ThreadSimpleView.cpp : implementation of the CThreadSimpleView class
//

#include "stdafx.h"
#include "ThreadSimple.h"

#include "ThreadSimpleDoc.h"
#include "ThreadSimpleView.h"
#include ".\threadsimpleview.h"
#include "ComputeDlg.h"
#include <afxmt.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

//volatile bool bThreadController;
CEvent threadStart;
CEvent threadEnd;

// CThreadSimpleView

IMPLEMENT_DYNCREATE(CThreadSimpleView, CView)

BEGIN_MESSAGE_MAP(CThreadSimpleView, CView)
	ON_COMMAND(ID_THREAD_START, OnThreadStart)
	ON_COMMAND(ID_THREAD_ENDTHREAD, OnThreadEndthread)
	ON_UPDATE_COMMAND_UI(ID_THREAD_START, OnUpdateThreadStart)
	ON_UPDATE_COMMAND_UI(ID_THREAD_ENDTHREAD, OnUpdateThreadEndthread)
	ON_MESSAGE(WM_THREADENDED, OnThreadEnded)
	ON_WM_LBUTTONDOWN()
	ON_WM_CREATE()
END_MESSAGE_MAP()

// CThreadSimpleView construction/destruction

CThreadSimpleView::CThreadSimpleView()
: m_bThreadRunning(false)
{
	// TODO: add construction code here

}

CThreadSimpleView::~CThreadSimpleView()
{
}

BOOL CThreadSimpleView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

// CThreadSimpleView drawing

void CThreadSimpleView::OnDraw(CDC* /*pDC*/)
{
	CThreadSimpleDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	if (!pDoc)
		return;

	// TODO: add draw code for native data here
}


// CThreadSimpleView diagnostics

#ifdef _DEBUG
void CThreadSimpleView::AssertValid() const
{
	CView::AssertValid();
}

void CThreadSimpleView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CThreadSimpleDoc* CThreadSimpleView::GetDocument() const // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CThreadSimpleDoc)));
	return (CThreadSimpleDoc*)m_pDocument;
}
#endif //_DEBUG


// CThreadSimpleView message handlers
UINT ThreadProc(LPVOID param) {
	::WaitForSingleObject(threadStart.m_hObject, INFINITE);
	::MessageBox((HWND) param, "Thread Activated", "Thread Start", MB_OK);
	long volatile nCount = 0;
	int bThreadController = true;
	while(bThreadController  && nCount < 20000000) {
		nCount++;
		int result = 
			::WaitForSingleObject(threadEnd.m_hObject, 0);
		bThreadController = result != WAIT_OBJECT_0;
	}
	::PostMessage((HWND) param, WM_THREADENDED, 0, 0);
	return 0;
}


void CThreadSimpleView::OnThreadStart()
{
	HWND hWnd = GetSafeHwnd();
	AfxBeginThread(ThreadProc, hWnd);
	threadStart.SetEvent();
}

void CThreadSimpleView::OnThreadEndthread()
{
	threadEnd.SetEvent();
}

void CThreadSimpleView::OnUpdateThreadStart(CCmdUI *pCmdUI)
{
	pCmdUI->Enable(true);//!bThreadController);
}

void CThreadSimpleView::OnUpdateThreadEndthread(CCmdUI *pCmdUI)
{
	pCmdUI->Enable(true);//bThreadController);
}

LRESULT CThreadSimpleView::OnThreadEnded(WPARAM wParam, LPARAM lParam) {
//	bThreadController = false;
	AfxMessageBox("Thread Ended");
	return 0L;
}

void CThreadSimpleView::OnLButtonDown(UINT nFlags, CPoint point)
{
	// TODO: Add your message handler code here and/or call default

	CComputeDlg dlg;
	dlg.DoModal();
}

int CThreadSimpleView::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CView::OnCreate(lpCreateStruct) == -1)
		return -1;

	// TODO:  Add your specialized creation code here

	return 0;
}
